//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_level1  0

extern int FastPeriod   = 12;
extern int SlowPeriod   = 26;
extern int SignalPeriod =  9;
extern int Price        = PRICE_CLOSE;

double macd[];
double signal[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,macd);
   SetIndexBuffer(1,signal);
      IndicatorShortName("kama MACD ("+FastPeriod+","+SlowPeriod+","+SignalPeriod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         macd[i]   = iAma(price,FastPeriod,i,0)-iAma(price,SlowPeriod,i,1);
         signal[i] = iAma(macd[i],SignalPeriod,i,2);
   }         
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workAma[][9];
#define _price 0
#define _diff  1
#define _ama   2
#define _fastend 0.666
#define _slowend 0.0645

double iAma(double price, int period, int i, int instanceNo)
{
   if (ArrayRange(workAma,0)!=Bars) ArrayResize(workAma,Bars); instanceNo *= 3; i=Bars-i-1; 
   
   //
   //
   //
   //
   //
   
      workAma[i][instanceNo+_price] = price;
      if (i<period)
      {
         if (i>0) 
               workAma[i][instanceNo+_diff] = MathAbs(price-workAma[i-1][instanceNo+_price]);
         else  workAma[i][instanceNo+_diff] = 0;
               workAma[i][instanceNo+_ama]  = price; 
         return(price);
      }
   
      //
      //
      //
      //
      //

      workAma[i][instanceNo+_diff] = MathAbs(price-workAma[i-1][instanceNo+_price]);
   			double efratio = 1;
            double signal  = MathAbs(workAma[i][instanceNo+_price]-workAma[i-period][instanceNo+_price]);
			   double noise   = workAma[i][instanceNo+_diff];
			   
			      for (int k=1; k<period && (i-k)>=0; k++) noise += workAma[i-k][instanceNo+_diff];
			      if (noise!= 0)
			          efratio = signal/noise;
			   double smooth  = MathPow(efratio*(_fastend-_slowend)+_slowend,2.0);
          workAma[i][instanceNo+_ama] = workAma[i-1][instanceNo+_ama]+smooth*(price-workAma[i-1][instanceNo+_ama]);
   return(workAma[i][instanceNo+_ama]);
}